<template>
  <b-button
    variant="success"
    v-b-modal.create-test-modal
    v-show="me && me.groups.includes('MOD')"
  >
    <b-icon-file-plus />
    Test

    <b-modal
      id="create-test-modal"
      :title="`Create ${system.name} test`"
      @ok="submit"
      ok-variant="success"
    >
      <p v-show="error" style="color: red">
        Something went wrong, please double-check your input or try it later
        again. Error message: {{ error }}
      </p>

      <b-form>
        <label for="name">Name</label>
        <b-form-input
          id="name"
          v-model="name"
          :state="name.length >= 1"
          placeholder="Test name"
          trim
        />

        <label for="description">Description</label>
        <b-form-textarea
          id="description"
          v-model="description"
          placeholder="Describe your test in a few words..."
          trim
        />

        <label for="group">Group</label>
        <b-form-input id="group" v-model="group" trim />

        <label for="steps">Steps</label>
        <b-form-textarea
          id="steps"
          v-model="steps"
          placeholder="Give the testers detailed instructions..."
          trim
        />

        <label for="weight">Weight</label>
        <b-form-select
          id="weight"
          v-model="weight"
          :options="['CRITICAL', 'HIGH', 'MEDIUM', 'LOW']"
        />
      </b-form>
    </b-modal>
  </b-button>
</template>

<script>
import gql from "graphql-tag";

export default {
  name: "CreateTest",
  data() {
    return {
      me: {
        groups: []
      },
      error: "",
      name: "",
      description: "",
      group: "default",
      steps: "",
      weight: "MEDIUM"
    };
  },
  apollo: {
    me: {
      query: gql`
        query {
          me {
            id
            name
            groups
            email
            joined
          }
        }
      `
    }
  },
  props: {
    system: Object
  },
  methods: {
    submit(e) {
      e.preventDefault();
      this.$apollo
        .mutate({
          mutation: gql`
            mutation($systemId: ID!, $test: TestInput!) {
              createTest(systemId: $systemId, test: $test) {
                id
              }
            }
          `,
          variables: {
            systemId: this.system.id,
            test: {
              name: this.name || undefined,
              description: this.description || undefined,
              group: this.group || "default",
              steps: this.steps || undefined,
              weight: this.weight || "MEDIUM"
            }
          }
        })
        .then(
          data => (window.location.href = `/test/${data.data.createTest.id}`)
        )
        .catch(error => {
          this.error = error;
        });
    }
  }
};
</script>
